# class ActionDispatch::FileHandler

### Public Class Methods

new(root, cache_control) click to toggle source

    # File lib/action_dispatch/middleware/static.rb, line 5
    def initialize(root, cache_control)
      @root          = root.chomp('/')
      @compiled_root = /^#{Regexp.escape(root)}/
      headers = cache_control && { 'Cache-Control' => cache_control }
      @file_server   = ::Rack::File.new(@root, headers)
    end

### Public Instance Methods

call(env) click to toggle source

    # File lib/action_dispatch/middleware/static.rb, line 26
    def call(env)
      @file_server.call(env)
    end

escape_glob_chars(path) click to toggle source

    # File lib/action_dispatch/middleware/static.rb, line 41
    def escape_glob_chars(path)
      path.force_encoding('binary') if path.respond_to? :force_encoding
      path.gsub(/[*?{}\[\]]/, "\\\\\\&")
    end

ext() click to toggle source

    # File lib/action_dispatch/middleware/static.rb, line 30
    def ext
      @ext ||= begin
        ext = ::ActionController::Base.page_cache_extension
        "{,#{ext},/index#{ext}}"
      end
    end

match?(path) click to toggle source

    # File lib/action_dispatch/middleware/static.rb, line 12
    def match?(path)
      path = path.dup

      full_path = path.empty? ? @root : File.join(@root, escape_glob_chars(unescape_path(path)))
      paths = "#{full_path}#{ext}"

      matches = Dir[paths]
      match = matches.detect { |m| File.file?(m) }
      if match
        match.sub!(@compiled_root, '')
        ::Rack::Utils.escape(match)
      end
    end

unescape_path(path) click to toggle source

    # File lib/action_dispatch/middleware/static.rb, line 37
    def unescape_path(path)
      URI.parser.unescape(path)
    end